## backward-cpp 1.4

=== CMakeLists.txt ===
#
# CMakeLists.txt
# Copyright 2013 Google Inc. All Rights Reserved.
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

cmake_minimum_required(VERSION 2.8.12)
project(backward CXX)

include(BackwardConfig.cmake)

# check if compiler is nvcc or nvcc_wrapper
set(COMPILER_IS_NVCC false)
get_filename_component(COMPILER_NAME ${CMAKE_CXX_COMPILER} NAME)
if (COMPILER_NAME MATCHES "^nvcc")
  set(COMPILER_IS_NVCC true)
endif()

# set CXX standard
set(CMAKE_CXX_STANDARD_REQUIRED True)
set(CMAKE_CXX_STANDARD 11)
if (${COMPILER_IS_NVCC})
  # GNU CXX extensions are not supported by nvcc
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()

###############################################################################
# COMPILER FLAGS
###############################################################################

if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_COMPILER_IS_GNUCXX)
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra")
	if (NOT ${COMPILER_IS_NVCC})
	  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic-errors")
	endif()
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
endif()

###############################################################################
# BACKWARD OBJECT
###############################################################################

add_library(backward_object OBJECT backward.cpp)
target_compile_definitions(backward_object PRIVATE ${BACKWARD_DEFINITIONS})
target_include_directories(backward_object PRIVATE ${BACKWARD_INCLUDE_DIRS})
set(BACKWARD_ENABLE $<TARGET_OBJECTS:backward_object> CACHE STRING
	"Link with this object to setup backward automatically")


###############################################################################
# BACKWARD LIBRARY (Includes backward.cpp)
###############################################################################
option(BACKWARD_SHARED "Build dynamic backward-cpp shared lib" OFF)

if(BACKWARD_SHARED)
    set(libtype SHARED)
endif()
add_library(backward ${libtype} backward.cpp)
target_compile_definitions(backward PUBLIC ${BACKWARD_DEFINITIONS})
target_include_directories(backward PUBLIC ${BACKWARD_INCLUDE_DIRS})

###############################################################################
# TESTS
###############################################################################

if(BACKWARD_TESTS)
	enable_testing()

	add_library(test_main SHARED test/_test_main.cpp)

	macro(backward_add_test src)
		get_filename_component(name ${src} NAME_WE)
		set(test_name "test_${name}")

		add_executable(${test_name} ${src} ${ARGN})

		target_link_libraries(${test_name} PRIVATE Backward::Backward test_main)

		add_test(NAME ${name} COMMAND ${test_name})
	endmacro()

	# Tests without backward.cpp
	set(TESTS
		test
		stacktrace
		rectrace
		select_signals
		)

	foreach(test ${TESTS})
		backward_add_test(test/${test}.cpp)
	endforeach()

	# Tests with backward.cpp
	set(TESTS
		suicide
		)

	foreach(test ${TESTS})
		backward_add_test(test/${test}.cpp ${BACKWARD_ENABLE})
	endforeach()
endif()

install(
    FILES "backward.hpp"
    DESTINATION ${CMAKE_INSTALL_PREFIX}/include
)
install(
    FILES "BackwardConfig.cmake"
    DESTINATION ${CMAKE_INSTALL_PREFIX}/lib/backward
)

=== debian/changelog ===
backward-cpp (1.4-5) unstable; urgency=medium

  * Fix Multi-Arch filed
  * Update Standards-Version to 4.5.0 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 08 Feb 2020 18:44:16 +0800

backward-cpp (1.4-4) unstable; urgency=medium

  * Add binutils-dev version restriction to autopkgtest
  * Add Multi-Arch foreign

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 09 Jan 2020 15:28:25 +0800

backward-cpp (1.4-3) unstable; urgency=medium

  * Add patch to fix FTBFS with binutils 2.34 (Closes: #948410)

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 08 Jan 2020 23:27:55 +0800

backward-cpp (1.4-2) unstable; urgency=medium

  * Update my email to zhsj@debian.org
  * Update Vcs-{Git,Browser} address
  * Update debhelper-compat to 12
  * Update Standards-Version to 4.4.1 (no changes)
  * Fix autopkgtest test case
  * Set Rules-Requires-Root to no

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 24 Oct 2019 23:19:49 +0800

backward-cpp (1.4-1) unstable; urgency=medium

  * Initial release. (Closes: #902400)

 -- Shengjing Zhu <i@zhsj.me>  Sat, 07 Jul 2018 09:42:11 +0800

=== debian/control ===
Source: backward-cpp
Section: libdevel
Priority: optional
Maintainer: Shengjing Zhu <zhsj@debian.org>
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 12),
Standards-Version: 4.5.0
Homepage: https://github.com/bombela/backward-cpp
Vcs-Git: https://salsa.debian.org/zhsj/backward-cpp.git
Vcs-Browser: https://salsa.debian.org/zhsj/backward-cpp

Package: libbackward-cpp-dev
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 binutils-dev,
 libdw-dev,
Description: Beautiful stack trace pretty printer for C++
 Backward spices the stack trace up when C++ programs run into fault.
 .
 It can also display code snippets with colored lines when the source files
 are accessible.
 .
 Backward is a header only library.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBACKWARD_TESTS=ON

=== debian/tests/control ===
Tests: build
Depends:
 binutils-dev (>= 2.33.50.20200105~),
 g++,
 libbackward-cpp-dev,
 libc6-dev,

## backward-cpp 1.5

=== debian/changelog ===
backward-cpp (1.5-2) unstable; urgency=medium

  * Allow stderr output in the autopkgtests (Closes: #964449)
    Workaround for binutils 2.35
  * Bump debhelper-compat to 13

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 08 Jul 2020 17:43:07 +0800

backward-cpp (1.5-1) unstable; urgency=medium

  * New upstream release v1.5
  * Drop 0001-Fix-build-with-binutils-2.34.patch.
    Applied in v1.5
  * Fix cmake config install patch

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 15 Apr 2020 03:15:30 +0800

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Rules-Requires-Root: no
 Build-Depends:
  cmake,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
 Standards-Version: 4.5.0
 Homepage: https://github.com/bombela/backward-cpp
 Vcs-Git: https://salsa.debian.org/zhsj/backward-cpp.git

## backward-cpp 1.6

=== debian/changelog ===
backward-cpp (1.6-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with CMake 4. (Closes: #1112752)

 -- Adrian Bunk <bunk@debian.org>  Sun, 26 Oct 2025 22:26:59 +0200

backward-cpp (1.6-1) unstable; urgency=medium

  * New upstream release v1.6
  * Update Standards-Version to 4.6.0 (no changes)
  * Add libunwind-dev to Suggests

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 01 Sep 2021 12:12:52 +0800

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends:
  cmake,
  debhelper-compat (= 13),
-Standards-Version: 4.5.0
+Standards-Version: 4.6.0
 Homepage: https://github.com/bombela/backward-cpp
 Vcs-Git: https://salsa.debian.org/zhsj/backward-cpp.git
 Vcs-Browser: https://salsa.debian.org/zhsj/backward-cpp
@@ -20,6 +20,7 @@
 Suggests:
  binutils-dev,
  libdw-dev,
+ libunwind-dev,
 Description: Beautiful stack trace pretty printer for C++
  Backward spices the stack trace up when C++ programs run into fault.
  .

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBACKWARD_TESTS=ON -DCMAKE_INSTALL_LIBDIR=lib

=== debian/tests/control ===
--- 
+++ 
@@ -4,3 +4,4 @@
  g++,
  libbackward-cpp-dev,
  libc6-dev,
+Restrictions: allow-stderr
